Add better python discovery

`x.ps1` and `x` will now search for python executables like `python3.9`
and `python3.10.exe`
This commit is contained in:
Albert Larsan 2022-10-13 10:20:39 +02:00
parent 4596f4f8b5
commit c83ddaef94
No known key found for this signature in database
GPG Key ID: 92709B88BB8F13EA
2 changed files with 18 additions and 1 deletions

6
x
View File

@ -29,5 +29,11 @@ for SEARCH_PYTHON in py python3 python python2; do
exec "$python" $extra_arg "$xpy" "$@"
fi
done
python=$(bash -c "compgen -c python" | grep '^python[2-3]\.[0-9]\+$' | head -n1)
if ! [ "$python" = "" ]; then
exec "$python" "$xpy" "$@"
fi
echo "$0: error: did not find python installed" >&2
exit 1

13
x.ps1
View File

@ -10,11 +10,15 @@ foreach ($arg in $args) {
$xpy_args += """$arg"""
}
function Get-Application($app) {
return Get-Command $app -ErrorAction SilentlyContinue -CommandType Application
}
foreach ($python in "py", "python3", "python", "python2") {
# NOTE: this only tests that the command exists in PATH, not that it's actually
# executable. The latter is not possible in a portable way, see
# https://github.com/PowerShell/PowerShell/issues/12625.
if (Get-Command $python -ErrorAction SilentlyContinue) {
if (Get-Application $python) {
if ($python -eq "py") {
# Use python3, not python2
$xpy_args = @("-3") + $xpy_args
@ -24,5 +28,12 @@ foreach ($python in "py", "python3", "python", "python2") {
}
}
$found = (Get-Application "python*" | Where-Object {$_.name -match '^python[2-3]\.[0-9]+(\.exe)?$'})
if (($null -ne $found) -and ($found.Length -ge 1)) {
$python = $found[0]
$process = Start-Process -NoNewWindow -Wait -PassThru $python $xpy_args
Exit $process.ExitCode
}
Write-Error "${PSCommandPath}: error: did not find python installed"
Exit 1